What's new webinar: AG Grid 36 and AG Charts 14 Join us for a webinar on 14th July at 2pm UTC+1 Register




Core Features

Advanced Features

JavaScript Data GridCell Components

Custom HTML / DOM inside Cells is achieved using Cell Components. Create Custom Cell Components to have any HTML markup in a cell. The grid comes with some Provided Cell Components for common grid tasks.

The example below shows adding images, hyperlinks, and buttons to a cell using Custom Cell Components. The custom button logs to the developer console when clicked.

Provided Components Copy Link

The grid comes with some built in Cell Components that cover some common cell rendering requirements.

Custom Components Copy Link

To render custom content in a grid cell, first define the custom cell component and then configure the column definition to use the component via cellRenderer or cellRendererSelector, passing custom parameters via cellRendererParams as required.

Creating Custom Components Copy Link

A cell renderer is either:

  • A function returning an HTML string or a DOM object
  • A class implementing the ICellRendererComp interface

Use the function variant of a Cell Component if you have no refresh or cleanup requirements (ie you don't need to implement the refresh or destroy functions).

interface ICellRendererComp {
    // Optional - props for rendering.
    init?(props: ICellRendererParams): void;

    // Mandatory - Return the DOM element of the component, this is what the grid puts into the cell
    getGui(): HTMLElement;

    // Optional - Gets called once by grid after rendering is finished - if your renderer needs to do any cleanup,
    // do it here
    destroy?(): void;

    // Mandatory - Get the cell to refresh. Return true if the refresh succeeded, otherwise return false.
    // If you return false, the grid will remove the component from the DOM and create
    // a new component in its place with the new values.
    refresh(params: ICellRendererParams): boolean;
}

When providing a class-based component, it is initialised with props containing, amongst other things, the value to be rendered. A full description of the props can be found below in the API Reference.

class CustomButtonComponent {
    // ...
    init(props) {
        // create the cell
        this.eGui = document.createElement('div');
        this.eGui.innerHTML = props.value;
    }
    // ...
}

When providing a function-based component, it receives the same props as its argument as would have been provided to the init method above. Below are some simple examples of Cell Components provided as simple functions:

// uppercase the value
colDef.cellRenderer = params => `${params.value.toUpperCase()}`;

// put a tooltip on the value
colDef.cellRenderer = params => `<span title="the tooltip">${params.value}</span>`;

// create a DOM object
colDef.cellRenderer = params => {
    const eDiv = document.createElement('div');
    eDiv.innerHTML = '<span class="my-css-class"><button class="btn-simple">Push Me</button></span>';
    return eDiv;
}

Providing Custom Components Copy Link

The Cell Component for a Column is set via colDef.cellRenderer and can be any of the following types:

  1. String: The name of a registered Cell Component, see Registering Custom Components
  2. Class: Direct reference to a Cell Component.
  3. Function: A function that returns either an HTML string or DOM element for display.
cellRendererCopy Link
any
Provide your own cell Renderer component for this column's cells.

The code snippet below demonstrates each of these method types.

const gridOptions = {
    columnDefs: [
        // 1 - String - The name of a Cell Component registered with the grid.
        {
            field: 'age',
            cellRenderer: 'agGroupCellRenderer',
        },
        // 2 - Class - Provide your own Cell Component directly without registering.
        {
            field: 'sport',
            cellRenderer: MyCustomCellRendererClass,
        },
        // 3 - Function - A function that returns an HTML string or DOM element for display
        {
            field: 'year',
            cellRenderer: params => {
                // put the value in bold
                return 'Value is <b>' + params.value + '</b>';
            }
        }
    ],

    // other grid options ...
}

Providing Custom Components Dynamically Copy Link

The colDef.cellRendererSelector function allows setting different Cell Components for different Rows within a Column.

The params passed to cellRendererSelector are the same as those passed to the Cell Renderer Component. Typically the selector will use this to check the row's contents and choose a renderer accordingly.

The result is an object with component and params to use instead of cellRenderer and cellRendererParams.

cellRendererSelectorCopy Link
CellRendererSelectorFunc
Callback to select which cell renderer to be used for a given row within the same column.

This following shows the selector choosing between Mood and Gender Cell Renderers based on the row data.

cellRendererSelector: params => {

    const type = params.data.type;

    if (type === 'gender') {
        return {
            component: GenderCellRenderer,
            params: {values: ['Male', 'Female']}
        };
    }

    if (type === 'mood') {
        return {
            component: MoodCellRenderer
        };
    }

    return undefined;
}

Another use case for the Selector function is to only render a custom cell component in leaf nodes when Row Grouping. This is done by checking params.node.group and returning undefined for the group nodes.

cellRendererSelector: params => {
    return params.node.group ? undefined : { component: CellRenderer };
},

The example below demonstrates the use of cellRendererSelector to dynamically select a Cell Component based on the row data.

  • The column 'Value' holds data of different types as shown in the column 'Type' (numbers/genders/moods).
  • colDef.cellRendererSelector is a function that selects the renderer based on the row data.
  • The column 'Rendered Value' show the data rendered applying the component and params specified by colDef.cellRendererSelector

Custom Props Copy Link

The props passed to the Cell Component can be complemented with custom props. This allows configuring reusable Cell Components - e.g. a component could have buttons that are optionally displayed via additional props.

Complement props to a cell renderer using the Column Definition attribute cellRendererParams. When provided, these props will be merged with the grid provided props.

cellRendererParamsCopy Link
any
Params to be passed to the cellRenderer component.
// define Cell renderer to be reused
const myCellRenderer = params => `<span style="color: ${params.color}">${params.value}</span>`;

// use with a colour
colDef.cellRenderer = myCellRenderer;
colDef.cellRendererParams = {
    color: 'guinnessBlack'
}

// use with another colour
colDef.cellRenderer = myCellRenderer;
colDef.cellRendererParams = {
    color: 'irishGreen'
}

This example shows rendering an image with and without custom props and using custom props to pass a callback to a button. The Refresh Data button triggers the cell components to refresh by randomising the success data. The Launch button logs a message to the developer console.

Dynamic Tooltips Copy Link

When working with Custom Cell Renderers it is possible to register custom tooltips that are displayed dynamically by calling the setTooltip method on the params passed to the component.

setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.

The example below demonstrates a dynamic tooltip being displayed on Cell Components. The following can be noted:

  • The Athlete column uses the shouldDisplayTooltip callback to only display Tooltips when the text is not fully displayed.

Defer Slow Cell Components Copy Link

If a Custom Cell Component is slow to render, the grid may appear unresponsive due to the custom component blocking the main thread. This can be avoided by deferring the rending of slow components as follows:

{
    cellRenderer: 'SlowCellRenderer',
    cellRendererParams: {
        deferRender: true
    }
}

Deferred components will be rendered after other cells and only after the grid has stopped scrolling. In the meantime, the loading cell renderer will be displayed. If Row Grouping is active only custom cells in leaf nodes will be deferred.

The example below demonstrates the use of deferRender to defer the rendering of an artificially slow cell component. The following can be noted when scrolling:

  • The column 'Slow Renderer' is deferred and shows the default skeleton cell loader.
  • The column 'Slow Renderer Custom' is deferred but uses a custom loading cell defined via colDef.loadingCellRenderer.
  • The column 'Fast Renderer' is a custom component but not deferred so renders immediately along with the other plain cells.
  • The cellRendererSelector only returns the Slow Cell Renderer for leaf nodes as an optimisation.

Accessing Instances Copy Link

After the grid has created an instance of a Cell Component for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the Cell Component that has nothing to do with the operation of the grid. Accessing Cell Components is done using the grid API getCellRendererInstances(params).

getCellRendererInstancesCopy Link
Function
Returns the list of active cell renderer instances.

An example of getting the Cell Component for exactly one cell is as follows:

// example - get cell renderer for first row and column 'gold'
const firstRowNode = api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = api.getCellRendererInstances(params);

if (instances.length > 0) {
    // got it, user must be scrolled so that it exists
    const instance = instances[0];
}

Note that this method will only return instances of the Cell Component that exists. Due to Row and Column Virtualisation, Cell Components will only exist for Cells that are within the viewport of the Vertical and Horizontal scrolls.

The example below demonstrates custom methods on Cell Components called by the application. The following can be noted:

  • The medal columns are all using the user defined MedalCellRenderer. The Cell Component has an arbitrary method medalUserFunction() which prints some data to the developer console.
  • The Gold button executes a method on all instances of the Cell Component in the gold column and prints the data to the developer console.
  • The First Row Gold button executes a method on the gold cell of the first row only and prints data to the developer console. Note that the getCellRendererInstances() method will return nothing if the grid is scrolled far past the first row showing row virtualisation in action.
  • The All Cells button executes a method on all instances of all Cell Components and prints data to the developer console.

Keyboard Navigation Copy Link

When using custom Cell Components, the custom Cell Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid cell with a custom Cell Component will focus the entire cell instead of any of the elements inside the custom cell renderer.

In order to handle focus in your custom cell component, implement Custom Cell Component Keyboard Navigation.

Handling Mouse Events Copy Link

By default when a cell is clicked on, the grid will perform actions including:

This behaviour may not be desirable for custom cell components, e.g. if they contain interactive elements. In this situation, the grid can be prevented from handling the mouse event ('click', 'dblclick', 'mousedown' or 'touchstart'), by passing the suppressMouseEventHandling callback to cellRendererParams.

const gridOptions = {
    columnDefs: [
        {
            colId: 'customButton',
            cellRenderer: CustomButtonComponent,
            cellRendererParams: {
                suppressMouseEventHandling: (params) => true,
            },
        },
    ],

    // other grid options ...
}
suppressMouseEventHandlingCopy Link
Function
Return true to prevent the grid from handling the following mouse events: 'click', 'dblclick', 'mousedown', 'touchstart'. This will prevent actions performed via the mouse, such as focusing a cell, selecting a row, starting a cell selection, or starting an edit. This will not prevent the grid from firing events for these mouse events (e.g. onCellClicked), but the events will have the isEventHandlingSuppressed property set to match the return value.

Note that whilst the callback will prevent the grid from performing actions, it will still continue to fire events (e.g. onCellClicked). These events will have the isEventHandlingSuppressed property set to true if the callback returns true.

The following example demonstrates using suppressMouseEventHandling with cell selection, row selection, and editing. Mouse events are suppressed for the Button column.

It is also possible to stop propagation on mouse events from within a custom cell component, but this must be done for each of the mouse events described above.

API Reference Copy Link

Properties available on the ICellRendererComp<TData = any> interface.

getGuiCopy Link
Function
Return the DOM element of your component, this is what the grid puts into the DOM
destroyCopy Link
Function
Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
Function
The init(params) method is called on the component once.
refreshCopy Link
Function
Get the cell to refresh. Return true if successful. Return false if not (or you don't have refresh logic), then the grid will refresh the cell for you.

Properties available on the ICellRendererParams<TData = any, TValue = any, TContext = any> interface.

Value to be rendered.
valueFormattedCopy Link
string | null | undefined
Formatted value to be rendered.
fullWidthCopy Link
boolean
True if this is a full width row.
pinnedCopy Link
'left' | 'right' | null
Pinned state of the cell.
The row's data. Data property can be undefined when row grouping or loading infinite row models.
The row node.
The cell's column definition.
The cell's column.
The grid's cell, a DOM div element.
eParentOfValueCopy Link
The parent DOM item for the cell renderer, same as eGridCell unless using checkbox selection.
getValueCopy Link
Function
Convenience function to get most recent up to data value.
setValueCopy Link
Function
Convenience function to set the value.
formatValueCopy Link
Function
Convenience function to format a value using the column's formatter.
refreshCellCopy Link
Function
Convenience function to refresh the cell.
registerRowDraggerCopy Link
Function
registerRowDragger: rowDraggerElement The HTMLElement to be used as Row Dragger dragStartPixels The amount of pixels required to start the drag (Default: 4) value The value to be displayed while dragging. Note: Only relevant with Full Width Rows. suppressVisibilityChange Set to true to prevent the Grid from hiding the Row Dragger when it is disabled.
setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.
The grid api.
Application context as set on gridOptions.context.

What's new webinar: AG Grid 36 and AG Charts 14 Join us for a webinar on 14th July at 2pm UTC+1 Register




Core Features

Advanced Features

Angular Data GridCell Components

Custom HTML / DOM inside Cells is achieved using Cell Components. Create Custom Cell Components to have any HTML markup in a cell. The grid comes with some Provided Cell Components for common grid tasks.

Angular Cell Renderers thumbnail

The example below shows adding images, hyperlinks, and buttons to a cell using Custom Cell Components. The custom button logs to the developer console when clicked.

Provided Components Copy Link

The grid comes with some built in Cell Components that cover some common cell rendering requirements.

Custom Components Copy Link

To render custom content in a grid cell, first define the custom cell component and then configure the column definition to use the component via cellRenderer or cellRendererSelector, passing custom parameters via cellRendererParams as required.

Creating Custom Components Copy Link

A cell renderer is either:

Use the function variant of a Cell Component if you have no refresh requirements.

interface ICellRendererAngularComp {
    // Mandatory - Params for rendering
    agInit(params: ICellRendererParams): void;

    // Mandatory - Return true if you have managed the cell refresh yourself in this method, otherwise return false.
    // If you return false, the grid will remove the component from the DOM and create a new component in its place
    // with the new values.
    refresh(params: ICellRendererParams): boolean;
}

When providing a class-based component, it is initialised with props containing, amongst other things, the value to be rendered. The full definition can be found below in the API Reference.

class CustomButtonComponent implements ICellRendererAngularComp {
  // ...
  agInit(props: ICellRendererParams): void {
    this.cellValue = props.value;
  }
  // ...

When using a function-based component, it receives the same props as its argument as would have been provided to the agInit method above. In the example below we're outputting a string value that depends on the cell value:

@Component({
    selector: 'my-app',
    template: `
        <ag-grid-angular
                [columnDefs]="columnDefs"
                ...other properties />`
})
export class AppComponent {
    columnDefs = [
        {
            headerName: "Value",
            field: "value",
            cellRenderer: params => params.value > 1000 ? "LARGE VALUE" : "SMALL VALUE"
        }
    ];
    //...
}

It is also possible to write a JavaScript-based Cell Renderer Component - refer to the documentation here for more information

Providing Custom Components Copy Link

The Cell Component for a Column is set via colDef.cellRenderer and can be any of the following types:

  1. String: The name of a registered Cell Component, see Registering Custom Components
  2. Class: Direct reference to a Cell Component.
  3. Function: A function that returns either an HTML string or DOM element for display.
cellRendererCopy Link
any
Provide your own cell Renderer component for this column's cells.

The code snippet below demonstrates each of these method types.

<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    // 1 - String - The name of a Cell Component registered with the grid.
    {
        field: 'age',
        cellRenderer: 'agGroupCellRenderer',
    },
    // 2 - Class - Provide your own Cell Component directly without registering.
    {
        field: 'sport',
        cellRenderer: MyCustomCellRendererClass,
    },
    // 3 - Function - A function that returns an HTML string or DOM element for display
    {
        field: 'year',
        cellRenderer: params => {
            // put the value in bold
            return 'Value is <b>' + params.value + '</b>';
        }
    }
];

Providing Custom Components Dynamically Copy Link

The colDef.cellRendererSelector function allows setting different Cell Components for different Rows within a Column.

The params passed to cellRendererSelector are the same as those passed to the Cell Renderer Component. Typically the selector will use this to check the row's contents and choose a renderer accordingly.

The result is an object with component and params to use instead of cellRenderer and cellRendererParams.

cellRendererSelectorCopy Link
CellRendererSelectorFunc
Callback to select which cell renderer to be used for a given row within the same column.

This following shows the selector choosing between Mood and Gender Cell Renderers based on the row data.

cellRendererSelector: params => {

    const type = params.data.type;

    if (type === 'gender') {
        return {
            component: GenderCellRenderer,
            params: {values: ['Male', 'Female']}
        };
    }

    if (type === 'mood') {
        return {
            component: MoodCellRenderer
        };
    }

    return undefined;
}

Another use case for the Selector function is to only render a custom cell component in leaf nodes when Row Grouping. This is done by checking params.node.group and returning undefined for the group nodes.

cellRendererSelector: params => {
    return params.node.group ? undefined : { component: CellRenderer };
},

The example below demonstrates the use of cellRendererSelector to dynamically select a Cell Component based on the row data.

  • The column 'Value' holds data of different types as shown in the column 'Type' (numbers/genders/moods).
  • colDef.cellRendererSelector is a function that selects the renderer based on the row data.
  • The column 'Rendered Value' show the data rendered applying the component and params specified by colDef.cellRendererSelector

Custom Props Copy Link

The props passed to the Cell Component can be complemented with custom props. This allows configuring reusable Cell Components - e.g. a component could have buttons that are optionally displayed via additional props.

Complement props to a cell renderer using the Column Definition attribute cellRendererParams. When provided, these props will be merged with the grid provided props.

cellRendererParamsCopy Link
any
Params to be passed to the cellRenderer component.
// define Cell Component to be reused
@Component({
    selector: 'colour-cell',
    template: `<span [style.color]="params.color">{{params.value}}</span>`
})
class ColourCellComp implements ICellRendererAngularComp {
    params!: ICellRendererParams;

    agInit(params: ICellRendererParams) {
        this.params = params;
    }

    refresh(params: ICellRendererParams) {
        this.params = params;
        // As we have updated the params we return true to let AG Grid know we have handled the refresh.
        // So AG Grid will not recreate the cell renderer from scratch.
        return true;
    }
}

@Component({
    selector: 'my-app',
    template: `
        <ag-grid-angular
                [columnDefs]="columnDefs"
                ...other properties />`
})
export class AppComponent {
    columnDefs = [
        {
            headerName: "Colour 1",
            field: "value",
            cellRenderer: ColourCellComp,
            cellRendererParams: {
                color: 'guinnessBlack'
            }
        },
        {
            headerName: "Colour 2",
            field: "value",
            cellRenderer: ColourCellComp,
            cellRendererParams: {
                color: 'irishGreen'
            }
        }
    ];

    //...
}

This example shows rendering an image with and without custom props and using custom props to pass a callback to a button. The Refresh Data button triggers the cell components to refresh by randomising the success data. The Launch button logs a message to the developer console.

Dynamic Tooltips Copy Link

When working with Custom Cell Renderers it is possible to register custom tooltips that are displayed dynamically by calling the setTooltip method on the params passed to the component.

setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.

The example below demonstrates a dynamic tooltip being displayed on Cell Components. The following can be noted:

  • The Athlete column uses the shouldDisplayTooltip callback to only display Tooltips when the text is not fully displayed.

Defer Slow Cell Components Copy Link

If a Custom Cell Component is slow to render, the grid may appear unresponsive due to the custom component blocking the main thread. This can be avoided by deferring the rending of slow components as follows:

{
    cellRenderer: 'SlowCellRenderer',
    cellRendererParams: {
        deferRender: true
    }
}

Deferred components will be rendered after other cells and only after the grid has stopped scrolling. In the meantime, the loading cell renderer will be displayed. If Row Grouping is active only custom cells in leaf nodes will be deferred.

The example below demonstrates the use of deferRender to defer the rendering of an artificially slow cell component. The following can be noted when scrolling:

  • The column 'Slow Renderer' is deferred and shows the default skeleton cell loader.
  • The column 'Slow Renderer Custom' is deferred but uses a custom loading cell defined via colDef.loadingCellRenderer.
  • The column 'Fast Renderer' is a custom component but not deferred so renders immediately along with the other plain cells.
  • The cellRendererSelector only returns the Slow Cell Renderer for leaf nodes as an optimisation.

Accessing Instances Copy Link

After the grid has created an instance of a Cell Component for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the Cell Component that has nothing to do with the operation of the grid. Accessing Cell Components is done using the grid API getCellRendererInstances(params).

getCellRendererInstancesCopy Link
Function
Returns the list of active cell renderer instances.

An example of getting the Cell Component for exactly one cell is as follows:

// example - get cell renderer for first row and column 'gold'
const firstRowNode = api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = api.getCellRendererInstances(params);

if (instances.length > 0) {
    // got it, user must be scrolled so that it exists
    const instance = instances[0];
}

Note that this method will only return instances of the Cell Component that exists. Due to Row and Column Virtualisation, Cell Components will only exist for Cells that are within the viewport of the Vertical and Horizontal scrolls.

The example below demonstrates custom methods on Cell Components called by the application. The following can be noted:

  • The medal columns are all using the user defined MedalCellRenderer. The Cell Component has an arbitrary method medalUserFunction() which prints some data to the developer console.
  • The Gold button executes a method on all instances of the Cell Component in the gold column and prints the data to the developer console.
  • The First Row Gold button executes a method on the gold cell of the first row only and prints data to the developer console. Note that the getCellRendererInstances() method will return nothing if the grid is scrolled far past the first row showing row virtualisation in action.
  • The All Cells button executes a method on all instances of all Cell Components and prints data to the developer console.

Keyboard Navigation Copy Link

When using custom Cell Components, the custom Cell Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid cell with a custom Cell Component will focus the entire cell instead of any of the elements inside the custom cell renderer.

In order to handle focus in your custom cell component, implement Custom Cell Component Keyboard Navigation.

Handling Mouse Events Copy Link

By default when a cell is clicked on, the grid will perform actions including:

This behaviour may not be desirable for custom cell components, e.g. if they contain interactive elements. In this situation, the grid can be prevented from handling the mouse event ('click', 'dblclick', 'mousedown' or 'touchstart'), by passing the suppressMouseEventHandling callback to cellRendererParams.

<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        colId: 'customButton',
        cellRenderer: CustomButtonComponent,
        cellRendererParams: {
            suppressMouseEventHandling: (params) => true,
        },
    },
];
suppressMouseEventHandlingCopy Link
Function
Return true to prevent the grid from handling the following mouse events: 'click', 'dblclick', 'mousedown', 'touchstart'. This will prevent actions performed via the mouse, such as focusing a cell, selecting a row, starting a cell selection, or starting an edit. This will not prevent the grid from firing events for these mouse events (e.g. onCellClicked), but the events will have the isEventHandlingSuppressed property set to match the return value.

Note that whilst the callback will prevent the grid from performing actions, it will still continue to fire events (e.g. onCellClicked). These events will have the isEventHandlingSuppressed property set to true if the callback returns true.

The following example demonstrates using suppressMouseEventHandling with cell selection, row selection, and editing. Mouse events are suppressed for the Button column.

It is also possible to stop propagation on mouse events from within a custom cell component, but this must be done for each of the mouse events described above.

API Reference Copy Link

Properties available on the ICellRendererComp<TData = any> interface.

getGuiCopy Link
Function
Return the DOM element of your component, this is what the grid puts into the DOM
destroyCopy Link
Function
Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
Function
The init(params) method is called on the component once.
refreshCopy Link
Function
Get the cell to refresh. Return true if successful. Return false if not (or you don't have refresh logic), then the grid will refresh the cell for you.

Properties available on the ICellRendererParams<TData = any, TValue = any, TContext = any> interface.

Value to be rendered.
valueFormattedCopy Link
string | null | undefined
Formatted value to be rendered.
fullWidthCopy Link
boolean
True if this is a full width row.
pinnedCopy Link
'left' | 'right' | null
Pinned state of the cell.
The row's data. Data property can be undefined when row grouping or loading infinite row models.
The row node.
The cell's column definition.
The cell's column.
The grid's cell, a DOM div element.
eParentOfValueCopy Link
The parent DOM item for the cell renderer, same as eGridCell unless using checkbox selection.
getValueCopy Link
Function
Convenience function to get most recent up to data value.
setValueCopy Link
Function
Convenience function to set the value.
formatValueCopy Link
Function
Convenience function to format a value using the column's formatter.
refreshCellCopy Link
Function
Convenience function to refresh the cell.
registerRowDraggerCopy Link
Function
registerRowDragger: rowDraggerElement The HTMLElement to be used as Row Dragger dragStartPixels The amount of pixels required to start the drag (Default: 4) value The value to be displayed while dragging. Note: Only relevant with Full Width Rows. suppressVisibilityChange Set to true to prevent the Grid from hiding the Row Dragger when it is disabled.
setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.
The grid api.
Application context as set on gridOptions.context.

What's new webinar: AG Grid 36 and AG Charts 14 Join us for a webinar on 14th July at 2pm UTC+1 Register




Core Features

Advanced Features

Vue Data GridCell Components

Custom HTML / DOM inside Cells is achieved using Cell Components. Create Custom Cell Components to have any HTML markup in a cell. The grid comes with some Provided Cell Components for common grid tasks.

The example below shows adding images, hyperlinks, and buttons to a cell using Custom Cell Components. The custom button logs to the developer console when clicked.

Provided Components Copy Link

The grid comes with some built in Cell Components that cover some common cell rendering requirements.

Custom Components Copy Link

To render custom content in a grid cell, first define the custom cell component and then configure the column definition to use the component via cellRenderer or cellRendererSelector, passing custom parameters via cellRendererParams as required.

Creating Custom Components Copy Link

A cell renderer is either:

  • A function returning an HTML string or a DOM object
  • A regular Vue component

Use the function variant of a Cell Component if you have no refresh requirements.

When providing a Vue component, you can access the params object via this.params in the usual methods (lifecycle hooks, methods etc), and via props.params when using setup. The full definition of params can be found below in the API Reference.

  // ...
  beforeMount() {
    this.cellValue = this.params.value;
  }
  // ...

When providing a function-based component, it receives the same params as its argument as would have been provided to the Vue component via this.params above. In the example below we're outputting a string value that depends on the cell value:

<template>
    <ag-grid-vue :columnDefs="columnDefs" ...other properties>
    </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";

export default {
    components: {
        AgGridVue
    },
    data() {
        return {
            columnDefs: [
                {
                    headerName: "Value",
                    field: "value",
                    cellRenderer: params => params.value > 1000 ? "LARGE VALUE" : "SMALL VALUE"
                }
            ]
        }
    }
    //...
}
</script>

It is also possible to write a JavaScript-based Cell Component - refer to the documentation here for more information

Providing Custom Components Copy Link

The Cell Component for a Column is set via colDef.cellRenderer and can be any of the following types:

  1. String: The name of a registered Cell Component, see Registering Custom Components
  2. Function: A function that returns either an HTML string or DOM element for display.
cellRendererCopy Link
any
Provide your own cell Renderer component for this column's cells.

The code snippet below demonstrates each of these method types.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    // 1 - String - The name of a Cell Component registered with the grid.
    {
        field: 'age',
        cellRenderer: 'agGroupCellRenderer',
    },
    // 2 - Function - A function that returns an HTML string or DOM element for display
    {
        field: 'year',
        cellRenderer: params => {
            // put the value in bold
            return 'Value is <b>' + params.value + '</b>';
        }
    }
];

Providing Custom Components Dynamically Copy Link

The colDef.cellRendererSelector function allows setting different Cell Components for different Rows within a Column.

The params passed to cellRendererSelector are the same as those passed to the Cell Renderer Component. Typically the selector will use this to check the row's contents and choose a renderer accordingly.

The result is an object with component and params to use instead of cellRenderer and cellRendererParams.

cellRendererSelectorCopy Link
CellRendererSelectorFunc
Callback to select which cell renderer to be used for a given row within the same column.

This following shows the selector choosing between Mood and Gender Cell Renderers based on the row data.

cellRendererSelector: params => {

    const type = params.data.type;

    if (type === 'gender') {
        return {
            component: 'GenderCellRenderer',
            params: {values: ['Male', 'Female']}
        };
    }

    if (type === 'mood') {
        return {
            component: 'MoodCellRenderer'
        };
    }

    return undefined;
}

Another use case for the Selector function is to only render a custom cell component in leaf nodes when Row Grouping. This is done by checking params.node.group and returning undefined for the group nodes.

cellRendererSelector: params => {
    return params.node.group ? undefined : { component: 'CellRenderer' };
},

The example below demonstrates the use of cellRendererSelector to dynamically select a Cell Component based on the row data.

  • The column 'Value' holds data of different types as shown in the column 'Type' (numbers/genders/moods).
  • colDef.cellRendererSelector is a function that selects the renderer based on the row data.
  • The column 'Rendered Value' show the data rendered applying the component and params specified by colDef.cellRendererSelector

Custom Props Copy Link

The props passed to the Cell Component can be complemented with custom props. This allows configuring reusable Cell Components - e.g. a component could have buttons that are optionally displayed via additional props.

Complement props to a cell renderer using the Column Definition attribute cellRendererParams. When provided, these props will be merged with the grid provided props.

cellRendererParamsCopy Link
any
Params to be passed to the cellRenderer component.
<template>
    <ag-grid-vue :columnDefs="columnDefs" ...other properties>
    </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";

// define Cell Component to be reused
const ColourComponent = {
  template: '<span :style="{color: params.color}">{{params.value}}</span>'
};

export default {
    components: {
        AgGridVue,
        ColourComponent
    },
    data() {
        return {
            columnDefs: [
                {
                    headerName: "Colour 1",
                    field: "value",
                    cellRenderer: 'ColourComponent',
                    cellRendererParams: {
                        color: 'guinnessBlack'
                    }
                },
                {
                    headerName: "Colour 2",
                    field: "value",
                    cellRenderer: 'ColourComponent',
                    cellRendererParams: {
                        color: 'irishGreen'
                    }
                }
            ]
        }
    }
    //...other properties & methods
}
</script>

This example shows rendering an image with and without custom props and using custom props to pass a callback to a button. The Refresh Data button triggers the cell components to refresh by randomising the success data. The Launch button logs a message to the developer console.

Dynamic Tooltips Copy Link

When working with Custom Cell Renderers it is possible to register custom tooltips that are displayed dynamically by calling the setTooltip method on the params passed to the component.

setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.

The example below demonstrates a dynamic tooltip being displayed on Cell Components. The following can be noted:

  • The Athlete column uses the shouldDisplayTooltip callback to only display Tooltips when the text is not fully displayed.

Defer Slow Cell Components Copy Link

If a Custom Cell Component is slow to render, the grid may appear unresponsive due to the custom component blocking the main thread. This can be avoided by deferring the rending of slow components as follows:

{
    cellRenderer: 'SlowCellRenderer',
    cellRendererParams: {
        deferRender: true
    }
}

Deferred components will be rendered after other cells and only after the grid has stopped scrolling. In the meantime, the loading cell renderer will be displayed. If Row Grouping is active only custom cells in leaf nodes will be deferred.

The example below demonstrates the use of deferRender to defer the rendering of an artificially slow cell component. The following can be noted when scrolling:

  • The column 'Slow Renderer' is deferred and shows the default skeleton cell loader.
  • The column 'Slow Renderer Custom' is deferred but uses a custom loading cell defined via colDef.loadingCellRenderer.
  • The column 'Fast Renderer' is a custom component but not deferred so renders immediately along with the other plain cells.
  • The cellRendererSelector only returns the Slow Cell Renderer for leaf nodes as an optimisation.

Accessing Instances Copy Link

After the grid has created an instance of a Cell Component for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the Cell Component that has nothing to do with the operation of the grid. Accessing Cell Components is done using the grid API getCellRendererInstances(params).

getCellRendererInstancesCopy Link
Function
Returns the list of active cell renderer instances.

An example of getting the Cell Component for exactly one cell is as follows:

// example - get cell renderer for first row and column 'gold'
const firstRowNode = api.getDisplayedRowAtIndex(0);
const params = { columns: ['gold'], rowNodes: [firstRowNode] };
const instances = api.getCellRendererInstances(params);

if (instances.length > 0) {
    // got it, user must be scrolled so that it exists
    const instance = instances[0];
}

Note that this method will only return instances of the Cell Component that exists. Due to Row and Column Virtualisation, Cell Components will only exist for Cells that are within the viewport of the Vertical and Horizontal scrolls.

The example below demonstrates custom methods on Cell Components called by the application. The following can be noted:

  • The medal columns are all using the user defined MedalCellRenderer. The Cell Component has an arbitrary method medalUserFunction() which prints some data to the developer console.
  • The Gold button executes a method on all instances of the Cell Component in the gold column and prints the data to the developer console.
  • The First Row Gold button executes a method on the gold cell of the first row only and prints data to the developer console. Note that the getCellRendererInstances() method will return nothing if the grid is scrolled far past the first row showing row virtualisation in action.
  • The All Cells button executes a method on all instances of all Cell Components and prints data to the developer console.

Keyboard Navigation Copy Link

When using custom Cell Components, the custom Cell Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid cell with a custom Cell Component will focus the entire cell instead of any of the elements inside the custom cell renderer.

In order to handle focus in your custom cell component, implement Custom Cell Component Keyboard Navigation.

Handling Mouse Events Copy Link

By default when a cell is clicked on, the grid will perform actions including:

This behaviour may not be desirable for custom cell components, e.g. if they contain interactive elements. In this situation, the grid can be prevented from handling the mouse event ('click', 'dblclick', 'mousedown' or 'touchstart'), by passing the suppressMouseEventHandling callback to cellRendererParams.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        colId: 'customButton',
        cellRenderer: CustomButtonComponent,
        cellRendererParams: {
            suppressMouseEventHandling: (params) => true,
        },
    },
];
suppressMouseEventHandlingCopy Link
Function
Return true to prevent the grid from handling the following mouse events: 'click', 'dblclick', 'mousedown', 'touchstart'. This will prevent actions performed via the mouse, such as focusing a cell, selecting a row, starting a cell selection, or starting an edit. This will not prevent the grid from firing events for these mouse events (e.g. onCellClicked), but the events will have the isEventHandlingSuppressed property set to match the return value.

Note that whilst the callback will prevent the grid from performing actions, it will still continue to fire events (e.g. onCellClicked). These events will have the isEventHandlingSuppressed property set to true if the callback returns true.

The following example demonstrates using suppressMouseEventHandling with cell selection, row selection, and editing. Mouse events are suppressed for the Button column.

It is also possible to stop propagation on mouse events from within a custom cell component, but this must be done for each of the mouse events described above.

API Reference Copy Link

Properties available on the ICellRendererComp<TData = any> interface.

getGuiCopy Link
Function
Return the DOM element of your component, this is what the grid puts into the DOM
destroyCopy Link
Function
Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
Function
The init(params) method is called on the component once.
refreshCopy Link
Function
Get the cell to refresh. Return true if successful. Return false if not (or you don't have refresh logic), then the grid will refresh the cell for you.

Properties available on the ICellRendererParams<TData = any, TValue = any, TContext = any> interface.

Value to be rendered.
valueFormattedCopy Link
string | null | undefined
Formatted value to be rendered.
fullWidthCopy Link
boolean
True if this is a full width row.
pinnedCopy Link
'left' | 'right' | null
Pinned state of the cell.
The row's data. Data property can be undefined when row grouping or loading infinite row models.
The row node.
The cell's column definition.
The cell's column.
The grid's cell, a DOM div element.
eParentOfValueCopy Link
The parent DOM item for the cell renderer, same as eGridCell unless using checkbox selection.
getValueCopy Link
Function
Convenience function to get most recent up to data value.
setValueCopy Link
Function
Convenience function to set the value.
formatValueCopy Link
Function
Convenience function to format a value using the column's formatter.
refreshCellCopy Link
Function
Convenience function to refresh the cell.
registerRowDraggerCopy Link
Function
registerRowDragger: rowDraggerElement The HTMLElement to be used as Row Dragger dragStartPixels The amount of pixels required to start the drag (Default: 4) value The value to be displayed while dragging. Note: Only relevant with Full Width Rows. suppressVisibilityChange Set to true to prevent the Grid from hiding the Row Dragger when it is disabled.
setTooltipCopy Link
Function
Sets a tooltip to the main element of this component. value The value to be displayed by the tooltip shouldDisplayTooltip A function returning a boolean that allows the tooltip to be displayed conditionally. This option does not work when enableBrowserTooltips={true}.
The grid api.
Application context as set on gridOptions.context.